#include <offset.h>
#include <asm.h>
#include <mipsregs.h>
#include <stackframe.h>


#define SAVE_STACK_UNWIND_INFO \
	sd     sp, -64 + 40(sp);	    \
	dsubu sp, sp, 64;		    \
	sd     a0, 0(sp);		    \
	sd     a1, 8(sp);		    \
	sd     a2, 16(sp);		    \
	sd     a3, 24(sp);		    \
	sd     ra, 32(sp); /* put ra in place of epc */ \
	sd     fp, 48(sp);		    \
	sd     ra, 56(sp);		  

#define RESTORE_STACK_UNWIND_INFO \
	ld     a0, 0(sp);		    \
	ld     a1, 8(sp);		    \
	ld     a2, 16(sp);		    \
	ld     a3, 24(sp);		    \
	ld     ra, 32(sp); /* put ra in place of epc */ \
	ld     fp, 48(sp);		    \
	ld     ra, 56(sp);		    \
	ld     sp, 40(sp);	   


NESTED(dump_stack, 64, sp)
	SAVE_STACK_UNWIND_INFO
	move a0, sp
	jal unwind_support_func
	nop
	RESTORE_STACK_UNWIND_INFO
	jr ra
	nop
END(dump_stack)
