/*************************************************************************
 Copyright 2003-2010 Netlogic Microsystems ("Netlogic"). All rights
 reserved.
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are
 met:
 1. Redistributions of source code must retain the above copyright
    notice, this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in
    the documentation and/or other materials provided with the
    distribution.
 THIS SOFTWARE IS PROVIDED BY Netlogic Microsystems ``AS IS'' AND
 ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL NETLOGIC OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 THE POSSIBILITY OF SUCH DAMAGE.
*******************************#NETL_2#**********************************/

#ifndef _SCHED_H
#define _SCHED_H

#define CLONE_VM      		(1 << 0)
#define CLONE_FS 		(1 << 1)
#define CLONE_FILES     	(1 << 2)
#define CLONE_SIGHAND   	(1 << 3)
#define CLONE_PTRACE    	(1 << 4)
#define CLONE_PARENT    	(1 << 5)
#define CLONE_THREAD    	(1 << 6)
#define CLONE_NEWNS     	(1 << 7)
#define CLONE_SYSVSEM   	(1 << 8)
#define CLONE_SETTLS		(1 << 9)
#define CLONE_PARENT_SETTID	(1 << 10)
#define CLONE_CHILD_CLEARTID	(1 << 11)
#define CLONE_DETACHED		(1 << 12)
#define CLONE_UNTRACED		(1 << 13)
#define CLONE_CHILD_SETTID	(1 << 14)
#define CLONE_STOPPED		(1 << 15)

extern int clone(int (*fn) (void *), void *child_stack, int flags, void *arg, ...);
#endif
