struct test_params aes256_cbc_sha1_test_params = {
//	.flag = 0,
	.cipher_alg = NLM_CIPHER_AES256,
	.cipher_mode = NLM_CIPHER_MODE_CBC, 
	.auth_alg = NLM_AUTH_SHA,
	.auth_mode = NLM_AUTH_MODE_SHA1,
	.cipher_iv_len = NLM_AES_IV_LEN,
	.cipher_key_len = NLM_AES256_KEY_LEN, 
//	.max_auth_key_len = NLM_SHA1_KEY_LEN, 
	.hmac = 1,
	.designer_desc_valid = 0, 
//	.designer_desc[4];
};

struct test_data cipher_aes256_cbc_auth_sha1_test_data[NR_TESTS_AES256_CBC_SHA1] = {
	/* http://grouper.ieee.org/groups/1619/email/msg01966.html */
	/* file saved as E:\Sandip\Technical External Docs\IPSec Docs\aes-cbc-hmac-test-vectors */
	{
	.enc = NLM_ENCRYPT,
	.len = 16,
	.auth_len = 16,
	.cipher_key="0000000000000000000000000000000000000000000000000000000000000000",
	.iv = "00000000000000000000000000000000",
	.in = "00000000000000000000000000000000",
	.out = "dc95c078a2408989ad48a21492842087",
	.digest ="59bb230e817ad3f377d623d2ca97eeffd0fd467c",
	.auth_key = "0000000000000000000000000000000000000000",
	.digest_len = 20,
	},
};
