/* Note > Key is expanded by appending zeros at the end of the key to make it B
 * size (blocksize). If key size is greater than B, H(K) is computed to get B
 * bytes output key*/
/* To be added... Different key sizes */

struct test_params md5_hmac_test_params = {
//	.flag = 0,
	.cipher_alg = NLM_CIPHER_BYPASS,
	.cipher_mode = 0, 
	.auth_alg = NLM_AUTH_MD5,
	.auth_mode = 0,
	.cipher_iv_len = 0,
	.cipher_key_len = 0,
	.hmac = 1,
//	.max_auth_key_len = NLM_MD5_KEY_LEN, 
	.designer_desc_valid = 0, 
//	.designer_desc[4];
};

struct test_data cipher_null_auth_md5_hmac_test_data[NR_TESTS_MD5_HMAC] = {
	/* rfc 2104 */
	{
	.len = 8,
	.auth_len = 8,
	.auth_key_len  = 16,
	.auth_key = "0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b0b",
	.in = "4869205468657265", /* Hi There */
	.digest = "9294727a3638bb1c13f48ef8158bfc9d",
	.digest_len = 16,
	},
	/* rfc 2104 */
	{
	.len = 28,
	.auth_len = 28,
	.auth_key_len  = 4,
	.auth_key = "4a656665", /* Jefe */
	.in = "7768617420646f2079612077616e7420666f72206e6f7468696e673f", /* What do you want for nothing?*/
	.digest = "750c783e6ab0b503eaa86e310a5db738",
	.digest_len = 16,
	},
	/* rfc 2104 */
	{
	.len = 50,
	.auth_len = 50,
	.auth_key_len  = 16,
	.auth_key = "AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA",
	.in = "DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD", /* 50 bytes*/
	.digest = "56be34521d144c88dbb8c733f0e8b3f6",
	.digest_len = 16,
	},
};
